common/models/User.php
<?php

namespace common\models;

use Yii;
use yii\base\NotSupportedException;
use yii\behaviors\TimestampBehavior;
use yii\db\ActiveRecord;
use yii\web\IdentityInterface;

/**
 * User model
 *
 * @property integer $id
 * @property string $username
 * @property string $password_hash
 * @property string $password_reset_token
 * @property string $verification_token
 * @property string $email
 * @property string $auth_key
 * @property integer $status
 * @property integer $created_at
 * @property integer $updated_at
 * @property string $password write-only password
 */
class User extends ActiveRecord implements IdentityInterface
{
    const STATUS_DELETED = 0;
    const STATUS_INACTIVE = 9;
    const STATUS_ACTIVE = 10;

    public static $access = [

        //1 level
        1 => 'магазин',
        2 => 'логисты',
        3 => 'АСЦ',

        //2 level
        4 => 'территориальный директор',
        5 => 'директор интернет-магазина',
        6 => 'руководитель АСЦ',

        //3 level
        7 => 'руководитель по клиентскому опыту',
        8 => 'директор направления',
        9 => 'менеджер проекта',

        //4 level
        10 => 'специалист по контролю качества обслуживания',
    ];

    public static $levels = [
        1 => [1, 2, 3],
        2 => [4, 5, 6],
        3 => [7, 8, 9],
        4 => [10],
    ];

    const SURVEY_TYPE_RETAIL = 1;
    const SURVEY_TYPE_DELIVERY = 2;
    const SURVEY_TYPE_B2B = 3;
    const SURVEY_TYPE_ASC = 4;
    public static $surveyType = [
        self::SURVEY_TYPE_RETAIL => 'Опрос розница',
        self::SURVEY_TYPE_DELIVERY => 'Опрос доставка',
        self::SURVEY_TYPE_B2B => 'Опрос b2b',
        self::SURVEY_TYPE_ASC => 'Опрос АСЦ',
    ];

    public static $responsible = [
        1 => 'управляющий',
        2 => 'зам. управляющего',
    ];

    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return '{{%user}}';
    }

    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            TimestampBehavior::className(),
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['username', 'email'], 'required'],
            [['surname_name', 'access', 'survey_type', 'phone', 'responsible', 'created_at', 'updated_at'], 'safe'],
            [['status'], 'integer'],
            [['username', 'password_hash', 'verification_token', 'password_reset_token', 'email'], 'string', 'max' => 255],
            [['auth_key'], 'string', 'max' => 32],
            [['username'], 'unique'],
            [['email'], 'unique'],
            ['status', 'default', 'value' => self::STATUS_ACTIVE],
            ['status', 'in', 'range' => [self::STATUS_ACTIVE, self::STATUS_INACTIVE, self::STATUS_DELETED]],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentity($id)
    {
        return static::findOne(['id' => $id, 'status' => self::STATUS_ACTIVE]);
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentityByAccessToken($token, $type = null)
    {
        throw new NotSupportedException('"findIdentityByAccessToken" is not implemented.');
    }

    /**
     * Finds user by username
     *
     * @param string $username
     * @return static|null
     */
    public static function findByUsername($username)
    {
        return static::findOne(['username' => $username, 'status' => self::STATUS_ACTIVE]);
    }

    /**
     * Finds user by password reset token
     *
     * @param string $token password reset token
     * @return static|null
     */
    public static function findByPasswordResetToken($token)
    {
        if (!static::isPasswordResetTokenValid($token)) {
            return null;
        }

        return static::findOne([
            'password_reset_token' => $token,
            'status' => self::STATUS_ACTIVE,
        ]);
    }

    /**
     * Finds user by verification email token
     *
     * @param string $token verify email token
     * @return static|null
     */
    public static function findByVerificationToken($token)
    {
        return static::findOne([
            'verification_token' => $token,
            'status' => self::STATUS_INACTIVE
        ]);
    }

    /**
     * Finds out if password reset token is valid
     *
     * @param string $token password reset token
     * @return bool
     */
    public static function isPasswordResetTokenValid($token)
    {
        if (empty($token)) {
            return false;
        }

        $timestamp = (int)substr($token, strrpos($token, '_') + 1);
        $expire = Yii::$app->params['user.passwordResetTokenExpire'];
        return $timestamp + $expire >= time();
    }

    /**
     * {@inheritdoc}
     */
    public function getId()
    {
        return $this->getPrimaryKey();
    }

    /**
     * {@inheritdoc}
     */
    public function getAuthKey()
    {
        return $this->auth_key;
    }

    /**
     * {@inheritdoc}
     */
    public function validateAuthKey($authKey)
    {
        return $this->getAuthKey() === $authKey;
    }

    /**
     * Validates password
     *
     * @param string $password password to validate
     * @return bool if password provided is valid for current user
     */
    public function validatePassword($password)
    {
        return Yii::$app->security->validatePassword($password, $this->password_hash);
    }

    /**
     * Generates password hash from password and sets it to the model
     *
     * @param string $password
     */
    public function setPassword($password)
    {
        $this->password_hash = Yii::$app->security->generatePasswordHash($password);
    }

    /**
     * Generates "remember me" authentication key
     */
    public function generateAuthKey()
    {
        $this->auth_key = Yii::$app->security->generateRandomString();
    }

    /**
     * Generates new password reset token
     */
    public function generatePasswordResetToken()
    {
        $this->password_reset_token = Yii::$app->security->generateRandomString() . '_' . time();
    }

    /**
     * Generates new token for email verification
     */
    public function generateEmailVerificationToken()
    {
        $this->verification_token = Yii::$app->security->generateRandomString() . '_' . time();
    }

    /**
     * Removes password reset token
     */
    public function removePasswordResetToken()
    {
        $this->password_reset_token = null;
    }

    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'user_id' => 'ID',
            'username' => 'Логин',
            'email' => 'Электронный адрес',
            'status' => 'Статус',
        ];
    }

    public function can($level)
    {
        $user = Yii::$app->user->getIdentity();
        return in_array($user->id, Yii::$app->authManager->getUserIdsByRole('admin'))
            || in_array($user->access, User::$levels[$level]);
    }

}

backend/controllers/UserController.php
<?php

namespace backend\controllers;

use backend\models\DeliverySurveyUploadForm;
use common\models\Area;
use common\models\Client;
use common\models\DeliveryDoc;
use common\models\DeliverySurvey;
use common\models\DeliverySurveySearch;
use common\models\ClientToken;
use common\models\Factory;
use common\models\TransportCompany;
use common\models\User;
use common\services\SmsService;
use yii\filters\AccessControl;
use yii\helpers\Url;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Yii;
use yii\web\UploadedFile;

class UserController extends Controller
{
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['index', 'create'],
                'rules' => [
//                    [
//                        'actions' => ['create'],
//                        'allow' => true,
//                    ],
                    [
                        'actions' => ['index', 'create', 'update', 'delete'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
        ];
    }

    public function actionIndex()
    {

        $users = User::find()->where(['!=', 'status', User::STATUS_DELETED])->all();

        return $this->render('index', [
            'id' => Yii::$app->controller->id,
            'users' => $users,
        ]);
    }

    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    public function actionCreate()
    {
        $request = Yii::$app->request;

        $model = new User();
        $model->status = User::STATUS_ACTIVE;
        if ($request->isPost) {
            if ($model->load($request->post()) && $model->validate()) {
                $model->status = array_key_exists('status', $this->request->post()['User']) ? User::STATUS_ACTIVE : User::STATUS_INACTIVE;
                $model->setPassword($this->request->post()['User']['password']);
                $model->save(false);
                $model->redirect(['/user']);
            }
        }

        return $this->render('create', [
            'id' => Yii::$app->controller->id,
            'model' => $model,
        ]);
    }

    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($this->request->isPost) {
            if ($model->load($this->request->post())) {
                $model->status = array_key_exists('status', $this->request->post()['User']) ? User::STATUS_ACTIVE : User::STATUS_INACTIVE;
                $model->setPassword($this->request->post()['User']['password']);
                $model->save();
                return $this->redirect(['/user']);
            }
        }

        return $this->render('update', [
            'id' => Yii::$app->controller->id,
            'model' => $model,
        ]);
    }

    public function actionDelete($id)
    {
        $model = $this->findModel($id);
        $model->status = User::STATUS_DELETED;
        $model->save();

        return $this->redirect(['/user']);
    }

    protected function findModel($id)
    {
        if (($model = User::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist . ');
    }

}

backend/views/user/_form.php
<?php

use yii\helpers\Html;
use yii\bootstrap4\ActiveForm;
use backend\views\widgets\UserFilterWidget;
use yii\helpers\Url;
use common\models\User;

?>

<div class="container">
    <div class="header">
        <div class="navbar-aside">
            <div class="mobile-menu btn-aside-menu toggle-sidebar">
                <div class="b-menu">
                    <div class="b-bun b-bun--top"></div>
                    <div class="b-bun b-bun--mid"></div>
                    <div class="b-bun b-bun--bottom"></div>
                </div>
            </div>
        </div>
    </div>
    <?= $this->render('/site/sidebar', [
        'id' => $id,
    ]) ?>
    <div class="content" id="content">
        <div class="page-content">
            <?= UserFilterWidget::widget([
                'title' => 'Пользователи / Редактирование пользователя',
            ]) ?>
            <div class="form-wrapper">
                <?php $form = ActiveForm::begin([
                    'id' => 'user-form',
                    'options' => ['class' => 'form-valid'],
                ]); ?>
                <div class="form-header">
                    Редактирование пользователя
                </div>
                <div class="form-group">
                    <div class="label">Введите Логин</div>
                    <input type="text" name="User[username]" value="<?= $model->username ?>" disabled>
                </div>
                <?php if (false): ?>
                    <div class="form-group">
                        <div class="label">Введите пароль</div>
                        <input type="text" name="User[password]" value="">
                    </div>
                <?php endif; ?>
                <div class="form-group">
                    <div class="label">ФИО сотрудника</div>
                    <input type="text" name="User[surname_name]" value="<?= $model->surname_name ?>">
                </div>
                <div class="form-group">
                    <div class="label">Права доступа</div>
                    <select name="User[access]" class="select2-single">
                        <?php foreach (User::$access as $id => $item): ?>
                            <option value="<?= $id ?>" <?= $model->access == $id ? ' selected' : '' ?>><?= $item ?></option>
                        <?php endforeach; ?>
                    </select>
                </div>
                <div class="form-group">
                    <div class="label">Выбор для какого опроса</div>
                    <select name="User[survey_type]" class="select2-single">
                        <?php foreach (User::$surveyType as $id => $item): ?>
                            <option value="<?= $id ?>" <?= $model->survey_type == $id ? ' selected' : '' ?>><?= $item ?></option>
                        <?php endforeach; ?>
                    </select>
                </div>
                <div class="form-group">
                    <div class="label">Введите email</div>
                    <input type="email" name="User[email]" value="<?= $model->email ?>">
                </div>
                <div class="form-group">
                    <div class="label">Введите телефон</div>
                    <input type="text" name="User[phone]" value="<?= $model->phone ?>">
                </div>
                <div class="form-group">
                    <div class="label">Ответственный сотрудник</div>
                    <select name="User[responsible]" class="select2-single">
                        <?php foreach (User::$responsible as $id => $item): ?>
                            <option value="<?= $id ?>" <?= $model->responsible == $id ? ' selected' : '' ?>><?= $item ?></option>
                        <?php endforeach; ?>
                    </select>
                </div>
                <div class="form-group check-group">
                    <label>
                        <input type="checkbox"
                               name="User[status]" <?= $model->status == USER::STATUS_ACTIVE ? ' checked' : '' ?>>
                        Активен
                    </label>
                </div>
                <div class="btn-wrap">
                    <button class="btn-default">Отправить</button>
                </div>
                <?php ActiveForm::end(); ?>
            </div>
        </div>
    </div>
</div>

backend/views/user/create.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use backend\views\widgets\UserFilterWidget;
use yii\helpers\Url;
use common\models\User;

?>

<div class="container">
    <div class="header">
        <div class="navbar-aside">
            <div class="mobile-menu btn-aside-menu toggle-sidebar">
                <div class="b-menu">
                    <div class="b-bun b-bun--top"></div>
                    <div class="b-bun b-bun--mid"></div>
                    <div class="b-bun b-bun--bottom"></div>
                </div>
            </div>
        </div>
    </div>
    <?= $this->render('/site/sidebar', [
        'id' => $id,
    ]) ?>
    <div class="content" id="content">
        <div class="page-content">
            <?= UserFilterWidget::widget([
                'title' => 'Пользователи / Создание пользователя',
            ]) ?>
            <div class="form-wrapper">
                <?php $form = ActiveForm::begin([
                    'id' => 'user-form',
                    'options' => ['class' => 'form-valid'],
                ]); ?>

                <div class="form-header">
                    Создание пользователя
                </div>
                <div class="form-group">
                    <div class="label">Введите Логин</div>
                    <input type="text" name="User[username]">
                </div>
                <div class="form-group">
                    <div class="label">Введите пароль</div>
                    <input type="text" name="User[password]">
                </div>
                <div class="form-group">
                    <div class="label">ФИО сотрудника</div>
                    <input type="text" name="User[surname_name]">
                </div>
                <div class="form-group">
                    <div class="label">Права доступа</div>
                    <select name="User[access]" class="select2-single">
                        <?php foreach (User::$access as $id => $item): ?>
                            <option value="<?= $id ?>"><?= $item ?></option>
                        <?php endforeach; ?>
                    </select>
                </div>
                <div class="form-group">
                    <div class="label">Выбор для какого опроса</div>
                    <select name="User[survey_type]" class="select2-single">
                        <?php foreach (User::$surveyType as $id => $item): ?>
                            <option value="<?= $id ?>"><?= $item ?></option>
                        <?php endforeach; ?>
                    </select>
                </div>
                <div class="form-group">
                    <div class="label">Введите email</div>
                    <input type="email" name="User[email]">
                </div>
                <div class="form-group">
                    <div class="label">Введите телефон</div>
                    <input type="text" name="User[phone]">
                </div>
                <div class="form-group">
                    <div class="label">Ответственный сотрудник</div>
                    <select name="User[responsible]" class="select2-single">
                        <?php foreach (User::$responsible as $id => $item): ?>
                            <option value="<?= $id ?>"><?= $item ?></option>
                        <?php endforeach; ?>
                    </select>
                </div>
                <div class="form-group check-group">
                    <label>
                        <input type="checkbox" name="User[status]" <?= $model->status == USER::STATUS_ACTIVE ? ' checked' : '' ?>>
                        Активен
                    </label>
                </div>
                <div class="btn-wrap">
                    <button class="btn-default">Отправить</button>
                </div>
                <?php ActiveForm::end(); ?>
            </div>
        </div>
    </div>
</div>

backend/views/user/index.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use backend\views\widgets\UserFilterWidget;
use yii\helpers\Url;
use common\models\User;

?>

<div class="container">
    <div class="header">
        <div class="navbar-aside">
            <div class="mobile-menu btn-aside-menu toggle-sidebar">
                <div class="b-menu">
                    <div class="b-bun b-bun--top"></div>
                    <div class="b-bun b-bun--mid"></div>
                    <div class="b-bun b-bun--bottom"></div>
                </div>
            </div>
        </div>
    </div>
    <?= $this->render('/site/sidebar', [
        'id' => $id,
    ]) ?>
    <div class="content" id="content">
        <div class="page-content">
            <?= UserFilterWidget::widget([
                'title' => 'Пользователи',
            ]) ?>
            <div class="users-btns-wrap">
                <a href="<?= Url::to(['user/create']) ?>" class="btn-user">Добавить пользователя</a>
                <a href="#" class="btn-user">Сбросить фильтры</a>
            </div>
            <div class="table-wrap">
                <div class="table-responsive users-table">
                    <table>
                        <thead>
                        <tr>
                            <th>
                                Логин
                            </th>
                            <th>
                                Пароль
                            </th>
                            <th>
                                ФИО сотрудника
                            </th>
                            <th>
                                Права доступа
                            </th>
                            <th class="long-col">
                                Для какого опроса
                            </th>
                            <th>
                                E-mail
                            </th>
                            <th>
                                Телефон
                            </th>
                            <th>
                            </th>
                        </tr>
                        </thead>
                        <tbody>
                        <tr class="filter-row">
                            <td>
                                <input type="text" placeholder="Введите Логин">
                            </td>
                            <td>
                                <input type="text" placeholder="Введите пароль">
                            </td>
                            <td>
                                <input type="text" placeholder="Фио сотрудника">
                            </td>
                            <td>
                                <select class="select2-single">
                                    <option value="0" selected>Все</option>
                                    <?php foreach (User::$access as $id => $item): ?>
                                        <option value="<?= $id ?>"><?= $item ?></option>
                                    <?php endforeach; ?>
                                </select>
                            </td>
                            <td>
                                <select class="select2-single">
                                    <option value="0">Все</option>
                                    <?php foreach (User::$surveyType as $id => $item): ?>
                                        <option value="<?= $id ?>"><?= $item ?></option>
                                    <?php endforeach; ?>
                                </select>
                            </td>
                            <td>
                                <input type="text" placeholder="Введите email">
                            </td>
                            <td>
                                <input type="text" placeholder="Введите телефон">
                            </td>
                            <td></td>
                        </tr>
                        <?php foreach ($users as $item): ?>
                            <tr>
                                <td><?= $item->username ?></td>
                                <td></td>
                                <td><?= $item->surname_name ?></td>
                                <td><?= array_key_exists($item->access, User::$access) ? User::$access[$item->access] : '' ?></td>
                                <td><?= array_key_exists($item->survey_type, User::$surveyType) ? User::$surveyType[$item->survey_type] : '' ?></td>
                                <td><?= $item->email ?></td>
                                <td><?= $item->phone ?></td>
                                <td>
                                    <div class="edit-wrap">
                                        <a href="<?= Url::to(['user/delete', 'id' => $item->id]) ?>" class="btn-delete"
                                           onclick="return confirm('Подтвердить удаление?')"></a>
                                        <a href="<?= Url::to(['user/update', 'id' => $item->id]) ?>"
                                           class="btn-edit"></a>
                                    </div>
                                </td>
                            </tr>
                        <?php endforeach; ?>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

backend/views/user/update.php
<?php

use yii\helpers\Html;

?>

<div class="user-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'id' => $id,
        'model' => $model,
    ]) ?>

</div>

backend/views/user/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model backend\models\DeliverySurvey */

$this->title = $model->survey_id;
$this->params['breadcrumbs'][] = ['label' => 'Delivery Surveys', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="delivery-survey-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'survey_id' => $model->survey_id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'survey_id' => $model->survey_id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'survey_id',
            'client_id',
            'doc_id',
            'question1',
            'question2',
            'question3',
            'question4',
            'status',
            'created_at',
            'updated_at',
            'status_updated_at',
        ],
    ]) ?>

</div>